/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import java.util.HashSet;

/**
 *
 * @author omozegieaziegbe
 */
public class OptimizedDuplicateFinderWithSet {
    
    public static int findFirstDuplicateIndex(int[] arr) {
        HashSet<Integer> seen = new HashSet<>();
        for (int i = 0; i < arr.length; i++) {
            if (seen.contains(arr[i])) {
                return i; // Found the second occurrence
            }
            seen.add(arr[i]); // Mark the element as seen
        }
        return -1; // No duplicate found
    }

    public static void main(String[] args) {
        int[] arr = {2, 5, 1, 2, 3, 5, 1, 2, 4};
        System.out.println("Index of first duplicate: " + findFirstDuplicateIndex(arr)); 
    }
    
}
