/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import java.util.HashSet;
import java.util.Set;
import java.util.stream.IntStream;

/**
 *
 * @author omozegieaziegbe
 */
public class StreamBasedDuplicateFinder {
    
    public static int findFirstDuplicateIndexWithStreams(int[] arr) {
        Set<Integer> seen = new HashSet<>();
        return IntStream.range(0, arr.length)
                .filter(i -> !seen.add(arr[i]))
                .findFirst()
                .orElse(-1);
    }

    public static void main(String[] args) {
        int[] arr = {2, 5, 1, 2, 3, 5, 1, 2, 4};
        System.out.println("Index of first duplicate: " + findFirstDuplicateIndexWithStreams(arr)); 
    }

}
